{% extends 'profile/layouts/admin/admin_layout.html' %}

{% load static %}
{% load humanize %}
{% load mathfilters %}
{% load custom_tags %}

{% block css %}
    <style>
        .img-bagss {
            position: absolute;
            top: 0;
            background-color: rgba(255, 0, 0, 0.8);
            text-align: center;
            font-weight: 500;
            line-height: 16px;
            padding: 5px 10px;
            color: #FFFFFF;
            border-radius: 5px 5px 5px 0;
        }
        .img-bagss .tag-bln { font-size: 15px; }
        
    </style>
{% endblock css %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page">Faktur Tagihan</li>
        </ol>
    </nav>

    <div class="card shadow mb-5">
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
            <h6 class="m-0 font-weight-bold text-info"><i class="fa fa-calculator"></i> Data Rincian Faktur Tagihan</h6>
           
            <div class="dropdown no-arrow">
                <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                </a>
            </div>
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-md-12">
                    <div class="d-flex">
                        <div class="flex-fill"> 
                            <div>
                                <h3 style=" margin: 0;" ><u>FAKTUR TAGIHAN</u></h3>
                                <p>No. Faktur
                                    {{dt_faktur.nofaktur}}
                                </p> 
                            </div>
                        </div>
                        <div class="flex-fill-right">
                            <div>
                                <p style="margin: 0; ">Pada {{data_spk.opd.namaopd}}</p>
                                <p>No. SPK {{data_spk.nospk}}</p> 
                            </div>
                        </div>
                    </div> 
                </div>
                <div class="col-md-12">
                    <div>
                        <table class="table table-striped table-bordered" id="" width="100%">
                            <thead class="bg-primary text-white text-center">
                                <!-- <th class="text-center">No</th> -->
                                <th class="text-center">Uraian Pekerjaan</th>
                                <th class="text-center" width="10%">Kuantitas</th>
                                <th class="text-center" width="12%">Satuan</th>
                                <th class="text-center" width="12%">Harga satuan  (Rp.)</th>
                                <th class="text-center" width="12%">Jumlah harga  (Rp.)</th>
                            </thead>
                            <tbody>
                                {% for item_rincianSPK, ssh in data_spk.rincian_rekening.items %}
                                <tr>
                                    <!-- <td></td> -->
                                    <td colspan="5" class="">
                                        # {{item_rincianSPK}}
                                    </td>
                                </tr>
                                {% for ssh in ssh %}
                                    <tr>
                                        <!-- <td></td> -->
                                        <td class="text-right ">{{ssh.uraian_ssh}}</td>
                                        <td class="text-right  ">{{ssh.volume|intcomma_no_decimal}}</td>
                                        <td class="text-center  ">{{ssh.satuan}}</td>
                                        <td class="text-right  ">Rp {{ssh.nilai}}</td>
                                        <td class="text-right ">Rp {{ssh.realisasi}}</td>
                                    </tr>
                                {% endfor %}
                            {% endfor %}
                                  
    
                                    
                                        
                                   <!--  <tr id="total-row">
                                        <td colspan="4"></td>
                                        <td><strong>JUMLAH A</strong></td>
                                        <td id="total-value"><strong>0</strong></td>
                                    </tr> -->
                            </tbody>    
                        </table>
                    </div>
                    <p style="text-align: center;">
                        <b>
                            Terbilang : 
                            {% for ins in bast_list %}
                                {{jumlah_harga|floatformat:0|cut:"."|cut:","|terbilang}}
                            {% endfor %}
                        </b>
                    </p>
                </div>
            </div>
        </div>
        <div class="card-header">
            <!-- <h6><b>Data Pajak</b> <a href="" class="btn btn-sm btn-warning"><span class="fa fa-plus"></span> Tambah Data Pajak</a> </h6> -->
            <button type="button"  class="btn btn-primary" onclick="TambahPajak(this)" data-alt="{% url 'profile:admin_create_rincian_faktur_detail' dt_faktur.id %}" data-modal-title="Tambah Pajak"><i class="bi bi-plus"></i> Tambah Data Pajak</button>
            {% if fakturpajakrincian_list %}
            <button type="button"  class="btn btn-primary" onclick="PrintFakturPajak(this)" data-alt="{% url 'profile:modal_print_faktur_pajak' data_spk.id %}" data-modal-title="Print Pajak"><i class="fa fa-print"></i> Print Faktur Pajak</button>
            {% endif %}
        </div>
        <div class="card-body">
            <div class="table-responsive">
                <table class="table table-striped table-bordered " border="1">
                    <thead  class="bg-success text-white text-center">
                        <th>No</th>
                        <th>Urai Pajak</th>
                        <th>Nilai Pajak</th>
                        <th>Aksi</th>
                        <!-- <th>Aksi</th> -->
                    </thead>
                    <tbody>
                        {% for item_rinc_pajak in fakturpajakrincian_list %}
                        <tr>
                            <td>{{forloop.counter}}</td>
                            <td>{{item_rinc_pajak.pajak.uraipajak}}</td>
                            <td>{{item_rinc_pajak.nilaipajak|intcomma}}</td>
                            <td>
                                
                                <div class="d-flex align-items-center justify-content-center px-3 py-2 mt-2">
                                    <button class="btn btn-success btn-sm btn-circle mr-3 mb-2" onclick="TambahPajak(this)" data-alt="{% url 'profile:admin_edit_rincian_faktur_detail' item_rinc_pajak.id %}" data-modal-title="Edit Pajak"><span class="fa fa-edit"></span></button>
                                    <button class="btn btn-primary btn-sm btn-circle mr-3 mb-2" onclick="PrintSSP(this)" data-alt="{% url 'profile:modal_print_ssp' item_rinc_pajak.id %}" data-modal-title="Print Surat Setoran Pajak" data-bs-toggle="tooltip" data-bs-placement="top" title="Cetak Surat Setoran Pajak"><span class="fa fa-print"></span></button>
                                    <a href="#" class="btn btn-sm btn-danger btn-circle mr-3 mb-2" 
                                    onclick="delete_detail_pajak(`{{ item_rinc_pajak.jenispajak }}`, '{{ item_rinc_pajak.id }}')"
                                    title="Arsipkan">
                                        <i class="bi bi-archive"></i>
                                    </a>
                                </div>
                            </td>
                            <!-- <td>Edit</td> -->
                        </tr>
                       {% endfor %}
                    </tbody>
                </table>
            </div>

        </div>

    </div>

{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %}
    <script>
        function TambahPajak(e){
            showModal(e, {size : 'large'})
        }
        function PrintFakturPajak(e){
            showModal(e, {size : 'large'})
        }
        function PrintSSP(e){
            showModal(e, {size : 'large'})
        }
        function Print_Faktur_pajak(e, ev){
            ShowIframeReport(
                `${$(e).data('url')}?tanggal=${encodeURIComponent($('#tglprint').val())}`,
                'Cetak Faktur Pajak',
                ev
            );
        }
        function Print_SSP(e, ev){
            ShowIframeReport(
                `${$(e).data('url')}?tanggal=${encodeURIComponent($('#tglprint').val())}`,
                'Cetak Surat Setoran Pajak',
                ev
            );
        }
        // Get all the elements with the class 'harga' (assuming 'harga' is the class of the cells in the Harga column)
        var hargaCells = document.querySelectorAll('.harga');
        
        // Initialize the total
        var total = 0;

        // Iterate through each cell in the Harga column
        hargaCells.forEach(function(cell) {
            // Parse the content of the cell as a float and add it to the total
            total += parseFloat(cell.textContent.replace(/[^\d.-]/g, ''));
        });

        // Update the total value in the total-row
        document.getElementById('total-value').textContent = total.toLocaleString('id-ID'); // Format the total with commas
    </script>
    <script>
       
        $(document).ready( function () {
            $('[data-tooltip="tooltip"]').tooltip();
            $('#table-list').DataTable();
            $('#table-archive').DataTable();
        });

        function editTagihan(element) {
            // Extract the value of the `data-rincian` attribute
            const rincianId = $(element).data('rincian'); // jQuery way
            // const rincianId = element.getAttribute('data-rincian'); // Vanilla JS way (alternative)
        
            if (rincianId) {
                const selector = `#jenispajak-${rincianId}`; // Construct the selector dynamically
                $(selector).on('change', function () {
                    const selectedOption = $(this).find(':selected');
                    const jenisPajak = parseFloat(selectedOption.data('persen'));
                    console.log(jenisPajak)
                    const totalPembayaran = parseFloat(document.getElementById(`totalpembayaran-${rincianId}`).value);
        
                    let hasilHitung = 0;
        
                    if (isNaN(jenisPajak) || jenisPajak === 0) {
                        // Handle case when no valid tax type is selected
                        hasilHitung = 0;
                    } else {
                        hasilHitung = Math.floor(totalPembayaran * (jenisPajak / 100));
                    }
        
                    // Format hasilHitung as a number with locale formatting
                    hasilHitung = Number.isInteger(hasilHitung) ? hasilHitung.toFixed(0) : hasilHitung.toFixed(2);
        
                    // Update <span> for displaying the formatted result
                    const spanElement = document.getElementById(`hasilhitung-display-${rincianId}`);
                    
                    if (spanElement) {
                        spanElement.innerText = parseFloat(hasilHitung).toLocaleString('id-ID', {
                            style: 'currency',
                            currency: 'IDR',
                        });
                    }
        
                    // Update <input> for storing the result
                    const inputElement = document.getElementById(`hasilhitung-${rincianId}`);
                    const labelElement = document.getElementById(`label-${rincianId}`);
                    if (labelElement) {
                        labelElement.textContent = 'Hasil Perhitungan:'; 
                    }
                    if (inputElement) {
                        inputElement.value = hasilHitung;

                    }
                    
                });
            } else {
                console.error('No valid data-rincian attribute found.');
            }
        }
        
        

        function hitungPajak() {
            var jenisPajak = document.getElementsByName("jenispajak")[0].value;
            var totalPembayaran = parseFloat(document.getElementById("totalpembayaran").value.replace(/\./g, ""));
            console.log(totalPembayaran, 'guggy')
            var hasilHitung = 0;
        

            if (jenisPajak === "pilih") {
                // Handle case when "Pilih Pajak" is selected
                // You can set hasilHitung to 0 or display an error message
                hasilHitung = 0;
            } else if (jenisPajak === "PPN") {
                hasilHitung = Math.floor((totalPembayaran * 11) / 111);
            } else if (jenisPajak === "PPH22") {
                
                // PAJAK PPh Ps 22  (1.5 %)   = (totalbayar-dpp) X 1.5 % 
                xDPP = Math.floor((totalPembayaran * 11) / 111);
                hasilHitung = Math.floor((totalPembayaran - xDPP) * 0.015);


            } else if (jenisPajak === "PPH23") {
                hasilHitung = totalPembayaran * 0.23;
            }
            
            //  hasilHitungbas = parseFloat(hasilHitung).toLocaleString('id-ID');
             // Menggunakan toLocaleString() untuk format angka
             hasilHitung = Number.isInteger(hasilHitung) ? hasilHitung.toFixed(0) : hasilHitung.toFixed(2);

                // Menetapkan nilai ke elemen <span>
                    var spanElement = document.getElementById("hasilhitung-display");
                    if (spanElement) {
                        spanElement.innerText = parseFloat(hasilHitung).toLocaleString('id-ID', { style: 'currency', currency: 'IDR' });
                    }

                // Menetapkan nilai ke elemen <input>
                var inputElement = document.getElementById("hasilhitung");
                if (inputElement) {
                    inputElement.value = hasilHitung;
                }
        }
        function hitungPajakDim(elements) {
            var jenisPajak = parseFloat($(elements).find(':selected').data('persen').replace(',', '.'));
            var totalPembayaran = parseFloat(document.getElementById("totalpembayaran").value.replace(/\./g, ""));
            var hasilHitung = 0;
            console.log(jenisPajak)

                if (jenisPajak === "pilih") {
                    // Handle case when "Pilih Pajak" is selected
                    // You can set hasilHitung to 0 or display an error message
                    hasilHitung = 0;
                } else {
                    console.log(jenisPajak)
                    hasilHitung = Math.floor((totalPembayaran * 100/111) * (jenisPajak / 100));
                } 


                //  hasilHitungbas = parseFloat(hasilHitung).toLocaleString('id-ID');
                // Menggunakan toLocaleString() untuk format angka
                hasilHitung = Number.isInteger(hasilHitung) ? hasilHitung.toFixed(0) : hasilHitung.toFixed(2);

                    // Menetapkan nilai ke elemen <span>
                        var spanElement = document.getElementById("hasilhitung-display");
                        if (spanElement) {
                            spanElement.innerText = parseFloat(hasilHitung).toLocaleString('id-ID', { style: 'currency', currency: 'IDR' });
                        }

                    // Menetapkan nilai ke elemen <input>
                    var inputElement = document.getElementById("hasilhitung");
                    var labelElement = document.getElementById("label-Perhitungan");
                    if (inputElement) {
                        inputElement.value = hasilHitung;
                    }
                    if (labelElement) {
                        labelElement.textContent = 'Hasil Perhitungan:'; 

                    }
                    
            }



        function restore_(nama, id){
                Swal.fire({
                    title: `Apakah anda yakin ingin memulihkan file ${nama}?`,
                    showCancelButton: true,
                    confirmButtonText: 'Pulihkan',
                    cancelButtonText: 'Batal',
                    }).then((result) => {
                    if (result.isConfirmed) {
                        $.ajax({
                            url: `/manage_panel/trans_spk/restore/${id}`,
                            data: {},
                            dataType: "html",
                            timeout: 10000,
                            beforeSend: function() {
                                Swal.fire({
                                    title: 'Memproses.........',
                                    allowEscapeKey: false,
                                    allowOutsideClick: false,
                                    showCancelButton: false,
                                    showConfirmButton: false,
                                    onOpen: () => {
                                        swal.showLoading();
                                    }
                                });
                            },
                            success: function(response){
                                Swal.fire(`Data SPK berhasil dipulihkan!`, '', 'success');
                                setTimeout(function(){
                                    window.location.href = "/manage_panel/trans_spk/";
                                }, 2000); 
                            },
                            error: function (xhr, ajaxOptions, thrownError) {
                                Swal.fire(`Data SPK gagal dipulihkan!`, '', 'error');
                            }
                        });
                        
                    }
                });
            }
            function delete_(action, nama, id){
                let pesan = action == 'soft_delete' ? "arsipkan" : "hapus";
                let confirmation = action == 'soft_delete' ? "Arsipkan" : "Hapus";
                Swal.fire({
                    title: `Apakah kamu yakin ingin meng${pesan} file ${nama}?`,
                    showCancelButton: true,
                    confirmButtonText: confirmation,
                    cancelButtonText: 'Batal',
                    }).then((result) => {
                    if (result.isConfirmed) {
                        $.ajax({
                            url: `/manage_panel/trans_spk/${action}/${id}`,
                            data: {},
                            dataType: "html",
                            timeout: 10000,
                            beforeSend: function() {
                                Swal.fire({
                                    title: 'Memproses.........',
                                    allowEscapeKey: false,
                                    allowOutsideClick: false,
                                    showCancelButton: false,
                                    showConfirmButton: false,
                                });
                                Swal.showLoading();
                            },
                            success: function(response){
                                Swal.fire(`Data SPK berhasil di${pesan}!`, '', 'success');
                                setTimeout(function(){
                                    window.location.href = "/manage_panel/trans_spk/";
                                }, 2000); 
                            },
                            error: function (xhr, ajaxOptions, thrownError) {
                                Swal.fire(`Data SPK gagal di${pesan}!`, '', 'error');
                            }
                        });
                        
                    }
                });
            }
            function delete_detail_pajak( nama, id){
                Swal.fire({
                    title: `Apakah kamu yakin ingin menghapus file ${nama}?`,
                    showCancelButton: true,
                    confirmButtonText: 'Hapus',
                    cancelButtonText: 'Batal',
                    }).then((result) => {
                    if (result.isConfirmed) {
                        $.ajax({
                            url: "{% url 'profile:admin_detail_faktur_delete' 0 %}".replace('0', id),
                            data: {},
                            dataType: "html",
                            timeout: 10000,
                            beforeSend: function() {
                                Swal.fire({
                                    title: 'Memproses.........',
                                    allowEscapeKey: false,
                                    allowOutsideClick: false,
                                    showCancelButton: false,
                                    showConfirmButton: false,
                                });
                                Swal.showLoading();
                            },
                            success: function(response){
                                Swal.fire(`Data Pajak berhasil dihapus!`, '', 'success');
                                setTimeout(function(){
                                    window.location.href = "";
                                }, 2000); 
                            },
                            error: function (xhr, ajaxOptions, thrownError) {
                                Swal.fire(`Data Pajak gagal dihapus!`, '', 'error');
                            }
                        });
                        
                    }
                });
            }
    </script>
{% endblock scripts_bawah %}
